//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****      XDS FREE - MARS 2002 - CopyRight  XDS Corporation		    *****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                                  *****
//***************************************************************************
//***************************************************************************

#include "XDSFree.h"

TDivers DD;
void glSortirProprement (string Msg,bool Sortir)
{
	FILE * fptr=fopen("ERROR.txt","w");
	int k=Msg.length();
        fwrite(Msg.c_str(),k,1,fptr);
	fclose(fptr);
	if (Sortir) exit(0);
}
void FillChar	 (void * pt,int qte,char value) {char * PtBis=(char *)pt;	for (int x=0;x<qte;x++) {*PtBis++=value;}}

//*****************************************************************************
//****   DD  ******************************************************************
//*****************************************************************************
//*** Nb est le nombre de int  classer. IdxOut contient les numros des cases, banane!
#define typ float
void TDivers::Classer(typ * Inn,typ * Out,int * IdxOut,int * Rang,int Nb)
{
	typ * In=(typ*)malloc(sizeof(typ)*Nb);memcpy(In,Inn,sizeof(typ)*Nb);
	//--- tri naf !!! ---
	int k,j,idx;
	typ max,min;//*** Je mettrai max+1 pour dire queue je l'ai dj trait.
	max=In[0];
	for (k=0;k<Nb;k++) if (In[k]>max)  max =In[k];

	for (k=0;k<Nb;k++)
	{
		min=max+1;
		idx=0;
		for (j=0;j<Nb;j++) if (In[j]<min) {min=In[j];idx=j;}
		//--- hop! on a le + petit actuel
		if (Out)    Out[k]   =min;      // ------> SI NULL on fait rien
		if (IdxOut) IdxOut[k]=idx;      // ------> SI NULL on fait rien
                if (Rang)   Rang[idx] =k;       // ------> SI NULL on fait rien
		In[idx]=max+1;
	}
	free(In);
	//--- t'es trop calm tellement c'est trop facile comme mthode
}
#undef typ
//***************************************************************************
void TDivers::Classer(int * Inn,int * Out,int * IdxOut,int * Rang,int Nb)
{
  float * innFLOAT=(float*)malloc(sizeof(float)*Nb);for (int k=0; k<Nb; k++) innFLOAT[k]=Inn[k];
  float * outFLOAT=(float*)malloc(sizeof(float)*Nb);
  Classer(innFLOAT, outFLOAT, IdxOut, Rang, Nb);         for (int k=0; k<Nb; k++) outFLOAT[k]=Out[k];
  free(outFLOAT);free(innFLOAT);
}
//***************************************************************************
long int TDivers::HexToDec (string In)
{       long int Out=0;        long int P  =1;        long int chif;
        for (int k=In.size()-1; k>=0; k--)
        {       char ch = In[k];
                     if (ch>='A' && ch<='F') chif = ch-'A'+10;
                else if (ch>='a' && ch<='f') chif = ch-'a'+10;
                else if (ch>='0' && ch<='9') chif = ch-'0';
                else return (-1);
                Out += chif * P;                P<<=4;
        }return(Out);
}
//*****************************************************************************
//****   XS  ****   XS2   *****************************************************
//*****************************************************************************

TXString XS;
#define IsChiffrePt(a) ( (a>='0' && a<='9') || (a=='.') || (a==',') || (a=='-'))

//double        _RTLENTRY _EXPFUNC atof(const char * __s);
//int           _RTLENTRY _EXPFUNC atoi(const char * __s);
//long          _RTLENTRY _EXPFUNC atol(const char * __s);

void TXString::StrCpy(char * Dst, const char * Src, int NbChMax)
{
    int k=0;
    while (*Src && k<NbChMax) {*Dst = *Src; Dst++;Src++;k++;}
    *Dst=0;
}

void   TXString::StrTovi   (string source, vint &viout) {
        viout.clear();
        vstring vs;
        for (uint k=0; k<source.size(); k++) if (!IsChiffrePt(source[k])) source[k]=' ';
        XS.Split(source," ",vs);
        forstl(vstring,vs)
        {
                viout.push_back(XS.StrToInt(*i));
                *i;
        }
}
void   TXString::StrTovf   (string source, vfloat &vfout) {
        vfout.clear();
        vstring vs;
        for (uint k=0; k<source.size(); k++) if (!IsChiffrePt(source[k])) source[k]=' ';
        XS.Split(source," ",vs);
        forstl(vstring,vs)
        {
                vfout.push_back(XS.StrToFloat(*i));
                *i;
        }
}
int   TXString::StrToInt  (string source) {return(atoi(source.c_str()));}
float TXString::StrToFloat(string source)
{
	char PtEntier [20];	char PtVirg[20];
	char *	Entier	= PtEntier;
	char *	Ent	    = PtEntier;
    char *  Str     = (char*)source.c_str();
	char *	Virg	= PtVirg;
	char *	Vir	    = PtVirg; // faut suivre, l.
	float Fact=1;
	if (*Str=='-') {Str++;Fact=-1;}
	if (*Str=='+') {Str++;}

    while (! (*Str>='0' && *Str<='9')) Str++;
	while ( (*Str!='.')&&(*Str!=',')&& IsChiffrePt(*Str) ) {*Entier++=*Str++;} *Entier=0;
	if (IsChiffrePt(*Str))
	{
		Str++;		//***Ben oui, faut sauter le '.' pfff, il est con lui....
		while (IsChiffrePt(*Str)) {*Virg=*Str;  Virg++;    Str++;} *Virg=0;
    }
	else *Vir=0;

    PtVirg[8]=0; // pas plus de 8 chiffres aprs la virgule. NON MAIS !!!
	float fEntier	=(float)StrToInt(Ent);
	float MultVir=1;
	while (*Vir=='0'&&*Vir) {MultVir*=0.1f;Vir++;}
	float fVir    	=(float)StrToInt(PtVirg);
	while (fVir>=1) {fVir/=10;}
	fVir		*=MultVir;
	return(Fact*(fEntier+fVir));
}
void   TXString::StrToChar      (string StrIN, char * Dst)
{char * src=(char*)StrIN.c_str();
while(*src) {*Dst++=*src++;};
*Dst=0;}
string TXString::IntToStr       (int    i) {char St[100];sprintf (St,"%d"   ,i);string R=St;return(R);}
string TXString::FloatToStr2Ch  (float fl) {char St[100];sprintf (St,"%.2f",fl);string R=St;return(R);}
string TXString::FloatToStr     (float fl) {char St[100];sprintf (St,"%f"  ,fl);string R=St;return(R);}
string TXString::T3fToStr2Ch    (void *ff) {float *f=(float*)ff; return(FloatToStr2Ch(f[0])+" "+FloatToStr2Ch(f[1])+" "+FloatToStr2Ch(f[2])+" ");}

void TXString::Trim       (string &str) // enlve les ' ', 10, 13 en db et fin de str
{
        uint k,j;
        for (k=0;    k<str.length() && (str[k]==10||str[k]==13||str[k]==' '); k++);
        for (j=str.length()-1;         (str[j]==10||str[j]==13||str[j]==' '); j--) if (j==0) return;
        str = str.substr(k,j-k+1);
}

void TXString::CutComment (string &str)
{
        int pos=-1;
        for (uint k=0; k<str.length()-1 && pos==-1; k++) if (str[k]=='/'&&str[k+1]=='/') pos=k;
        if (pos==-1) return;
        str = str.substr(0,pos);
}

struct my_tolower{ char operator()(char c) const { return std::tolower(static_cast<unsigned char>(c));} };
struct my_toupper{ char operator()(char c) const { return std::toupper(static_cast<unsigned char>(c));} };
char easytolower(char in){   if(in<='Z' && in>='A')     return in-('Z'-'z');   return in; }
string TXString::ToLower(const string &str)
{
    string data = str;
    transform(data.begin(), data.end(), data.begin(), easytolower);
    return(data);
}

void TXString::Upperize(string &s) {transform(s.begin(), s.end(), s.begin(), my_toupper());}
void TXString::Lowerize(string &s) {transform(s.begin(), s.end(), s.begin(), my_tolower());}


#define npos -1
// ne supporte pas d'emplacement VIDE : a les supprime
void TXString::Split      (string &str, string Separ, vstring &vsout) // "TX=1000" renvoie "TX","1000"
{
        uint deb=0;
        int fin=str.find(Separ,deb);
        if (fin==npos) {vsout.push_back(str);return;}

        while (fin != npos)
        {
                string ss = str.substr(deb,fin-deb);
                if (ss!="") vsout.push_back(ss);
                deb=fin+Separ.length();
                fin=str.find(Separ,deb);
        }
        if (deb!=0) vsout.push_back(str.substr(deb,str.length()));
}
void TXString::Spliti     (string &str, string Separ, vint    &viout) // "100 45" renvoie {100,45}
{
        vstring vs; Split(str,Separ,vs);
        forstl(vstring,vs)
        {
                string ss=*i;
                XS.Trim(ss);
                if (ss.length()==0) continue;
                viout.push_back(XS.StrToInt(ss));
        }
}
//void TXString::Splitf     (string &str, string Separ, vfloat  &vfout); // "100 45" renvoie {100,45}

string TXString::ReplaceAll (const string &strIN, string Find, string ReplaceBy) // attention  la rcursivit non terminale ! :)
{
    string res = strIN;
    int pos = res.find( Find );

    while (pos!=npos)
    {
        res = res.replace(pos,Find.length(),ReplaceBy);
        int newpos = pos + ReplaceBy.length();
        pos = res.find(Find.c_str(), newpos );
    }
    return(res);
}

bool TXString::MemeDeb(string str1,string str2)
{
        uint s1 = str1.size();
        uint s2 = str2.size();
        uint min = (s1<=s2 ? s1 : s2);
        for (uint k=0; k<min; k++) if (str1[k]!=str2[k]) return(false);
        return(true);
}
TXString2 XS2;
//*****************************************************************************
//*****************************************************************************
string TXString2::vstring2string  (vstring &vs,string sep)
{
        string ss;
//        forstl(vstring,vs) ss+=*i+(i==&vs.back()?(string)"":sep);
        return(ss);
}
string TXString2::vint2string     (vint    &vi,string sep)
{
        string ss;
//        forstl(vint,vi)   ss += XS.IntToStr(*i)+(i==&vi.back()?(string)"":sep);
        return(ss);
}
string TXString2::vfloat2string   (vfloat  &vf,string sep)
{
        string ss;
//        forstl(vfloat,vf) ss += XS.IntToStr(*i)+(i==&vf.back()?(string)"":sep);
        return(ss);
}
void TXString2::StringToChar (string StrSRC, char * StrDST)
{
        uint k;
        for (k=0; k<StrSRC.length(); k++) StrDST[k]=StrSRC.c_str()[k];
        StrDST[k]=0;
}
string TXString2::ExtractExt(const string &NomCplet)
{
        unsigned int kP=0;
        for (unsigned int k=1;k<NomCplet.length();k++) if (NomCplet[k]=='.') kP=k;
        if (kP==0) return("");
        if (kP>=NomCplet.size()-1) return("");

        string res;
        for (unsigned int k=kP+1; k<NomCplet.size(); k++)
        res.push_back(NomCplet[k]);

        return(res);
}
//*****************************************************************************
string TXString2::ExtractNameWithoutPath(const string &NomCplet)
{
    size_t found;
    found=NomCplet.find_last_of("/\\");
    if (found==(uint)npos) return(NomCplet);
    return(NomCplet.substr(found+1));

}
//*****************************************************************************
string TXString2::ExtractPath(const string &NomCplet, bool WithSlash)
{
      size_t found;
      found=NomCplet.find_last_of("/\\");
      if (found==(uint)npos) return("");
      string res = NomCplet.substr(0,found);
      if (WithSlash) res += "\\";
      return (res);
}
//*****************************************************************************
string TXString2::ExtractNameNoExt(const string &NomCplet)
{
        int kP=0;
        for (uint k=1;k<NomCplet.length();k++) if (NomCplet[k]=='.') kP=k;
        if (kP==0) return(NomCplet);
        string res = NomCplet;
        res.resize(kP);
        return(res);
}
//*****************************************************************************
string TXString2::ExtractNameNoExtNoPath(const string &NomCplet)
{
    return(ExtractNameWithoutPath(ExtractNameNoExt(NomCplet)));
}
//*****************************************************************************
bool TXString2::HasChar(char ch, string Str)
{
        return (Str.find(ch,0)!=(uint)npos);
}
CHAR wide_to_narrow(WCHAR w){return CHAR(w);}
//*****************************************************************************
//****   Files     ************************************************************
//*****************************************************************************
#define XCHAR char
TFiles Files;
//*****************************************************************************
bool TFiles::IsDirectory(string NomFich){return(Exists(NomFich));}
//*****************************************************************************
string TFiles::GetCurrentDir()
{
    XCHAR lpBuffer[556];
    GetCurrentDirectory( sizeof(lpBuffer),lpBuffer );
    //--- version 1 : XCHAR == CHAR
    string res = lpBuffer; return(res);
    //--- version 2 : XCHAR == WCHAR
/*
    char lpcBuffer[1000];
    XS2.WCHAR2char300(lpBuffer,lpcBuffer);
    string res = lpcBuffer;
    return(res);
*/
}
//*****************************************************************************
void TFiles::Delete      (string NomFich) {
        if (!Exists(NomFich))   glSortirProprement ("Error deleting "+NomFich);
        else   remove(NomFich.c_str());
}
void TFiles::Dir (string StrWhat, vstring & vs, bool AvecRep, bool AvecStrRep)
{
   WIN32_FIND_DATA      ffd;
   HANDLE               hFind   = INVALID_HANDLE_VALUE;

   // version 1 : XCHAR == CHAR
   hFind = FindFirstFile(StrWhat.c_str(), &ffd);

   // version 2 : XCHAR == WCHAR
/*
   XCHAR lpout[1000]; : XS2.char2WCHAR300 ( StrWhat.c_str(), lpout);
   hFind = FindFirstFile(lpout, &ffd);
*/

   string Path = XS2.ExtractPath(StrWhat,true);
   if (hFind == INVALID_HANDLE_VALUE) {return;}
   do
   {
      if ((ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && (!AvecRep)) ;
      else {
            // version 1 : XCHAR == CHAR
            string filenamestr = ffd.cFileName;

            // version 2 : XCHAR == WCHAR
/*
            XCHAR * filename = ffd.cFileName;
            XS2.WCHAR2char300(filename , StrChar);
            string filenamestr = StrChar;
*/
            if (AvecStrRep) filenamestr = Path+filenamestr;
            vs.push_back(filenamestr);
      }
   }
   while (FindNextFile(hFind, &ffd) != 0);
   FindClose(hFind);
}
//*****************************************************************************
void TFiles::DeleteDir  (string StrDir,string StarPointStar)
{       vstring vs;
        Dir(StrDir+"\\"+StarPointStar,vs,false);
        forstl(vstring,vs) Delete( StrDir + "\\" + *i );  // jamais teste
}
//*****************************************************************************
void TFiles::CreateDir (string StrDir) {CreateDirectory(StrDir.c_str(),NULL);}
void TFiles::RemoveDir (string StrDir) {RemoveDirectory(StrDir.c_str());}
//*****************************************************************************
void TFiles::Rename          (string OldName, string NewName)
{
        if (!Files.Exists (OldName)) glSortirProprement ("Error renaming "+OldName); else
        rename( OldName.c_str() , NewName.c_str() );
}
//*****************************************************************************
void TFiles::Execute(string StrDir, string StrCommand)
{       if (StrDir=="") StrDir="./"; else if (StrDir[StrDir.length()-1]!='\\'&&StrDir[StrDir.length()-1]!='/') StrDir=StrDir+"\\";
        STARTUPINFO si;      PROCESS_INFORMATION pi;
        ZeroMemory( &si, sizeof(si) ); si.cb = sizeof(si);
        ZeroMemory( &pi, sizeof(pi) );

        // version 1 : XCHAR == char
            XCHAR WCommand[300]; strcpy( WCommand , StrCommand.c_str() );
                XCHAR WDir[300]; strcpy( WDir     ,     StrDir.c_str() );

        // version 2 : XCHAR == WCHAR
        /*
            XCHAR WCommand[300]; XS2.char2WCHAR300( StrCommand.c_str() , WCommand);
                XCHAR WDir[300]; XS2.char2WCHAR300( StrDir.c_str()     , WDir);
        */

        if( !CreateProcess( NULL,   // No module name (use command line)
            WCommand,	    // Command line
            NULL,                   // Process handle not inheritable
            NULL,                   // Thread handle not inheritable
            FALSE,                  // Set handle inheritance to FALSE
            0,                      // No creation flags
            NULL,                   // Use parent's environment block
            WDir,         // NULL pour rpertoire courant
            &si,                    // Pointer to STARTUPINFO structure
            &pi )                   // Pointer to PROCESS_INFORMATION structure
        ) {glSortirProprement( ("Pb execution "+StrCommand).c_str() );return;}
}
//*****************************************************************************
void TFiles::Executebat(cstring &StrPath, cvstring &vs, bool AvecEnter)
{
    TFilew FW;
    FW.Open("LastCommand.bat");
    vstring myvs = vs;
    forstl(vstring,myvs) FW.Wri_string(*i,true);
    if (AvecEnter) {
        FW.Wri_string("@echo ------------------------- Press Any Key ------------------------------",true);
        FW.Wri_string("@GetKey",true);
    }
    FW.Close();
    Files.Transform2DOS  ("LastCommand.bat");
    Files.Execute(StrPath,"LastCommand.bat");
}
//*****************************************************************************
void TFiles::Executebat(cstring &StrPath, cstring &StrCommand, bool AvecEnter)
{
    vstring vs;
    vs.push_back(StrCommand);
    Executebat(StrPath,vs,AvecEnter);
}
//*****************************************************************************
#define QbIt(a,b) if(FF.p[k]==a) *Dst=b
void TFiles::Transform2DOS(string NomFichSrc, string NomFichDst)
{
    //--- 1 --- Lecture
    int size = Files.Size(NomFichSrc);
    TFilerb FF; FF.Load(NomFichSrc);
    char * DstOri = (char*)malloc(size+10000);
    char * Dst=DstOri;

    //--- 2 --- Transformation
    for (int k=0; k<size; k++)
    {
        *Dst = FF.p[k];
        QbIt('',129);        QbIt('',130);        QbIt('',131);        QbIt('',132);        QbIt('',133);
        QbIt('',135);        QbIt('',136);        QbIt('',137);        QbIt('',138);        QbIt('',139);
        QbIt('',140);        QbIt('',147);        QbIt('',148);        QbIt('',150);        QbIt('',151);
        if (FF.p[k]=='%') {Dst++;*Dst='%';} // c'est %% au lieu de % en DOS :)
        Dst++;
    }

    //--- 3 --- Ecriture
    TFilew FW; FW.Open(NomFichDst);
    FW.Wri_data(DstOri,size);
    FW.Close();
    free(DstOri);
}
//*****************************************************************************
bool TFiles::Exists (string NomFich)
{
	FILE * fptr=NULL;
        fptr=fopen(NomFich.c_str(),"r");
	if (fptr==NULL) {return (false);}
	fclose(fptr);
	return (true);
}
//*****************************************************************************
long TFiles::Size(string NomFich)
{
	FILE * fptr;
        fptr=fopen(NomFich.c_str(),"r");
	if (fptr==NULL) {return (false);}

    long curpos, length;
    curpos = ftell(fptr);
    fseek(fptr, 0L, SEEK_END);
    length = ftell(fptr);
    fseek(fptr, curpos, SEEK_SET);

    fclose(fptr);
    return length;
}
//*****************************************************************************
bool TFiles::Copy (string FichSrc, string FichDst)
{
        if (!Exists(FichSrc)) return(false);
        int s=Size(FichSrc);
        FILE * fptrS = fopen(FichSrc.c_str(),"rb");
        FILE * fptrD = fopen(FichDst.c_str(),"wb");
        void * Data=malloc(s);
        fread  (Data , s , 1 , fptrS);
        fwrite (Data , s , 1 , fptrD);
        free(Data);
        fclose(fptrS);
        fclose(fptrD);
        return(true);
}
//*****************************************************************************
void TFiles::LoadDir (string Path, vstring &OutFiles, string ext, bool AvecDir) // ext = "" pour avoir tout
{
        DIR * dir= opendir(Path.c_str());           // Comment tre sr qu'il n'y a pas de FUITE de MEMOIRE ?????
        if (!dir) return;
        dirent * dp;
        string Act, ExtAct;
        dp=readdir(dir);
        while (dp)
        {
            Act = dp->d_name;
            ExtAct = XS2.ExtractExt(Act);
            if (Act=="")                goto NEXT;
            if (!AvecDir && ExtAct=="") goto NEXT;
            if ( ext=="" || ext==ExtAct ) OutFiles.push_back(Act);
            NEXT :
            dp=readdir(dir);
        }
        closedir(dir);
}
//*****************************************************************************
void TFiles::LoadRep( string Path, vstring &OutRep, bool AvecPointEtPointPoint)
{
        DIR * dir= opendir(Path.c_str());           // Comment tre sr qu'il n'y a pas de FUITE de MEMOIRE ?????
        if (!dir) return;
        dirent * dp;
        string Act, ExtAct;
        dp=readdir(dir);
        while (dp)
        {
            Act = dp->d_name;
            ExtAct = XS2.ExtractExt(Act);
            if ( ExtAct=="" )
            if (AvecPointEtPointPoint || Act[0]!='.')
            OutRep.push_back(Act);
            dp=readdir(dir);
        }
        closedir(dir);
}
//*****************************************************************************
//****   Filec     ************************************************************
//*****************************************************************************
TFilec Filec;

string TFilec::Loads  (string NomFich, string Champ){TFileINI FF;FF.Load(NomFich);FF.BuildMap();return(FF.maps[Champ]);}
int    TFilec::Loadi  (string NomFich, string Champ){return(XS.StrToInt  ( Loads(NomFich,Champ) ));}
float  TFilec::Loadf  (string NomFich, string Champ){return(XS.StrToFloat( Loads(NomFich,Champ) ));}
void   TFilec::Loadvi (string NomFich, string Champ,vint &vi){XS.StrTovi ( Loads(NomFich,Champ) , vi );}

void   TFilec::Saves  (string NomFich, string Champ, string val)
{
        TFileINI FF(NomFich);
        vstring vsFich;
        forstl(vstring,FF.strs)
        {
                vstring vs;
                XS.Split(*i,"=",vs);
                bool good=false;
                if (vs.size()==2)
                {
                        string ChampAct = *vs.begin(); XS.Trim(ChampAct);
                        if (ChampAct==Champ)  // on va mme garder le bon nombre d'espaces... youhouuu !!
                        {
                        int pos = i->find('=',0);
                        *i = i->substr(0,pos+1);
                        *i += " " + val;
                        vsFich.push_back(*i);
                        good=true;
                        }
                };
                if (!good) vsFich.push_back(*i);
        }
        //--- Sauvegader
        TFilew FW(NomFich);
        FW.Wri_vs(vsFich);
        FW.Close();
}


//*****************************************************************************
//*****************************************************************************
//************** 1 ******* TFile  *********************************************
//*****************************************************************************
//*****************************************************************************

bool TFile::Load(string NomFich)
{       if (!Files.Exists(NomFich)) glSortirProprement(NomFich);
        size=Files.Size(NomFich);
        fptr=fopen(NomFich.c_str(),"rb");
        Data=(char*)malloc(size+1);
        fread(Data,size,1,fptr);        Str=Data;
        Str[size]=0;
        fclose(fptr);
        return(true);
}
string TFile::CopyLineGoNxt ()
{
        char DST[1000];
        char *D=DST;
        while (*Str!=10 && *Str!=13 && *Str && !eof() )
        { *D=*Str++;D++;}
        *D=0;
        string Res=DST;
        GoNxtLineFull(1);
        return(Res);
} // copie Str -> Dst jusqu' fin ligne

string TFile::CopyWordGoNxt ()
{
        char DST[1000]; char *D=DST;
        while (*Str!=10 && *Str!=13 && *Str && *Str!=' ' && *Str!=9 && !eof() )
        {
                *D=*Str++;
                D++;}
        *D=0;string Res=DST;
        return(Res);
} // copie Str -> Dst jusqu' fin ligne

int TFile::ReadIntAct()
{
        char Nb[100]; char * nb=Nb;  while (  (*Str=='-') || (*Str=='+') || ((*Str>='0')&&(*Str<='9')) ) {*nb++=*Str++;}
        *nb=0;
        return(XS.StrToInt(Nb));
}

float TFile::ReadFloatAct()
{
        char Nb[100]; char * nb=Nb;  while (  (*Str=='-') || (*Str=='+') || (*Str=='.') || ((*Str>='0')&&(*Str<='9')) ) {*nb++=*Str++;}
        *nb=0;
        return(XS.StrToFloat(Nb));
}
float TFile::ReadFloatMove()
{
        char Nb[100]; char * nb=Nb;  while (  (*Str=='-') || (*Str=='+') || (*Str=='.') || ((*Str>='0')&&(*Str<='9')) ) {*nb++=*Str++;}
        *nb=0;
        MoveToNxtChar();
        return(XS.StrToFloat(Nb));
}
int TFile::ReadNxtIntEgal() // Renvoie le prochain entier form par la ligne aprs le prochain '=' et met Str aprs le '='
{
        GoNxtChar('=');
        MoveToNxtChar();
        return(XS.StrToInt(CopyWordGoNxt().c_str() ));
}
float TFile::ReadNxtFloatEgal() // Renvoie le prochain float  form aprs le prochain '=' et met Str aprs le '='
{
        GoNxtChar('=');        MoveToNxtChar();        return(XS.StrToFloat(CopyWordGoNxt()));
}
string TFile::ReadNxtStrEgal2() // Renvoie le prochain string form aprs le prochain '=' et met Str aprs le '='
{
        GoNxtChar('=');        MoveToNxtChar();        return(ReadStrAct());
}
string TFile::ReadNxtStrEgal() // Renvoie le prochain entier form par la ligne aprs le prochain '=' et met Str  la NxtLigne
{
        GoNxtChar('=');        MoveToNxtChar();        return(string(CopyLineGoNxt()));
}
string TFile::ReadStrAct()  // Renvoie le String depuis Str jusqu'au caractre ENTER ou 0 ou espace
{       char * S=Str; char Dst[1000]; char * D=Dst;
        int k=0;
        while ((*S!=10)&&(*S!=13)&&(*S!=' ')&&(*S!=9)&&(*S)&&(S-Data<size)&&(k<1000)) {*D=*S; D++; S++; k++;} *D=0;
        Str=S; MoveToNxtChar(); string Rep=Dst;       return(Rep);
}
string TFile::ReadStrActNoMove()  // Renvoie le String depuis Str jusqu'au caractre ENTER ou 0 ou espace
{       char * S=Str; char Dst[1000]; char * D=Dst;
        int k=0;
        while ((*S!=10)&&(*S!=13)&&(*S!=' ')&&(*S!=9)&&(*S)&&(S-Data<size)&&(k<1000)) {*D=*S; D++; S++; k++;} *D=0;
        Str=S; string Rep=Dst;       return(Rep);
}
string TFile::ReadStrFinLgn()  // Renvoie le String depuis Str jusqu'au caractre ENTER ou 0, et ne bouge pas Str
{
        char * S=Str; char Dst[1000]; char * D=Dst;
        int k=0;
        while ((*S!=10)&&(*S!=13)&&(*S)&&(S-Data<size)&&(k<1000)) {*D=*S; D++; S++; k++;} *D=0;
        string Rep=Dst;       return(Rep);
}
string TFile::ReadToNxtChar(char Ch)  // Renvoie le String depuis Str jusqu'au caractre Ch ou ENTER ou 0 ou eof et place Str aprs le Ch
{
    char * S=Str; char Dst[1000]; char * D=Dst;
    int k=0;
    while ((*S!=Ch)&&(*S!=10)&&(*S!=13)&&(*S)&&(S-Data<size)&&(k<1000)) {*D=*S; D++; S++; k++;} *D=0;
    string Rep=Dst;       Str=(*S==Ch?S+1:S); return(Rep);
}
bool TFile::MoveJustAfter(char * chars) // part du principe qu'on le TROUVE !!
{
    int n = 0;
    int k;
    char * ch = chars;    while (*ch) {ch++; n++;}
    bool cbon;
    while (1)
    {
        if (eof()) glSortirProprement("mot pas trouv");
        cbon=true;
        for (k=0; k<n; k++)
            if (Str[k]!=chars[k]) {cbon=false;break;}
        if (cbon)
        {
            for (int j=0; j<n; j++) Str++;
            return(true);
        }
        Str++;
    }
}
//************************************************************
//******* TFileINI  ******************************************
//************************************************************
void TFileINI::Load(string NomFich, bool Buildmap)
{       //--- 1 --- lecture du fichier
        if (!Files.Exists(NomFich)) glSortirProprement(NomFich);
        int size    = Files.Size(NomFich);
        FILE * fptr = fopen(NomFich.c_str(),"rb");
        char * Data = (char*)malloc(size+1);
        fread(Data,size,1,fptr);
        fclose(fptr);
        //--- 2 --- dcoupage en lignes
        strs.clear();
        char * lgn  = (char*)malloc(size+1);    // jamais une ligne dpassera la taille du fichier
        char * src, *dst;        src=Data;
        while (*src)
        {
                dst = lgn;
                while (*src>=15) {*dst=*src;dst++;src++;}
                *dst=0;
                int NbEnt=0;
                while (*src<15) {NbEnt+=(*src==10);src++; if (*src==0)break;}
                strs.push_back(lgn);
                for (int k=0; k<NbEnt-1; k++) strs.push_back("");
        }
        free(Data);                             // les infos sont stoques dans strs
        free(lgn);
        if (Buildmap) BuildMap();
}
//-----------------------------------------------------------------------------
void TFileINI::Nettoie_strs() // dgage les lignes vides, les lignes commentes et les commentaires en fin de ligne pour "strs"
{
        forstl(vstring,strs) XS.CutComment(*i);
        vstring vsout;
        forstl(vstring,strs)
        {
                int len = i->length();
                if (len!=0) vsout.push_back(*i);
        }
        strs = vsout;
}
//-----------------------------------------------------------------------------
//  BuildMap()
//     1) dgage les lignes vides, les lignes commentes, et les commentaires en fin de ligne.
//     2) cre map<string,string> mapss. Exemple : "TX = 1400 1500   " met maps["TX"]="1400 1500"

void TFileINI::BuildMap()
{
        Nettoie_strs();
        maps.clear();

        forstl(vstring,strs)
        {
                vstring vsout;
                XS.Split(*i,"=",vsout);
                if (vsout.size()!=2) continue;
                XS.Trim(vsout[0]);
                XS.Trim(vsout[1]);
                maps[vsout[0]]=vsout[1];
        }
}
//************************************************************
//******* TFileCSV  ******************************************
//************************************************************
void TFileCSV::Save(string NomFich)
{
    TFilew Fw;
    Fw.Open(NomFich);
    for (uint kLgn=0; kLgn<res.size(); kLgn++)
    {
        for (uint kCol=0; kCol<res[kLgn].size(); kCol++)
        {
            Fw.Wri_string(res[kLgn][kCol]);
            if (kCol!=res[kLgn].size()-1)
            Fw.Wri_string(";");
        }
        if (kLgn!=res.size()-1)
        Fw.Wri_Enter();
    }
    Fw.Close();
}
void TFileCSV::Load(string NomFich)
{
    TFile F;
    F.Load(NomFich);

    string caseAct;
    vstring vs;
    res.clear();
    int NbL=0;
    while (!F.eof())
    {
        vs.clear();
        while (*F.Str && *F.Str!=10 && *F.Str!=13)
        {
            caseAct = F.ReadToNxtChar(';');
            vs.push_back(caseAct);
        }
        res.push_back(vs);
        F.GoNxtLineFull(1);
        NbL++;
    }
}


//-----------------------------------------------------------------------------
bool TFilerb::Open(string NomFich)             {fptr=fopen(NomFich.c_str() , "rb");return(fptr!=NULL);}
void TFilerb::Close()                          {if (fptr==NULL) return; fclose(fptr); fptr=NULL; }
bool TFilerb::Load(string NomFich)             {
    if (!Open(NomFich)) return(false);
    int s=Files.Size(NomFich); p=(char*)malloc(s);
    Read_data(p,s);Close();return(true);
}
bool TFilerb::Read_string2   (string &s)    {int ss; char TMP[1000]; Read_int(ss);  Read_data(TMP,ss);
                TMP[ss]=0; s=TMP;return(true);}
bool TFilerb::Read_string100 (string &s)    {char TMP[100]; Read_data(TMP,100); s=TMP;return(true);}
//-----------------------------------------------------------------------------
char Ent[2]={13,10};
bool TFilew::Open(string NomFich)                {fptr=fopen(NomFich.c_str() , "wb");return(fptr!=NULL);}
bool TFilew::Wri_string(const string &AS, bool Enter)  {
if (fptr==NULL) return(false);fwrite(AS.c_str(),AS.length(),1,fptr);if (Enter) Wri_data(Ent,2);return(true);}
bool TFilew::Wri_vs (vstring &vs)                {if (fptr==NULL) return(false);forstl(vstring,vs){Wri_string(*i , true);}return(true);} //  i!=&vs.back());}return(true);} QT = caca prout
bool TFilew::Wri_Enter(int Nb)                   {if (fptr==NULL) return(false);for (int k=0; k<Nb; k++) Wri_data(Ent,2); return(true);}
void TFilew::Close()                             {if (fptr==NULL) return; fclose(fptr); fptr=NULL; }
bool TFilew::Wri_intStr (int i,bool Enter)       {string str = XS.IntToStr(i); return( Wri_string( str,Enter) ); }
bool TFilew::Wri_string2   (string s)            {Wri_int(s.size());Wri_data((void*)s.c_str() , s.size());return(true);}
bool TFilew::Wri_string100 (string s)            {char TMP[100];
        XS.StrToChar(s,TMP);
        Wri_data(TMP,100);return(true);}
bool TFilew::Wri_strfloat (float * f, int Nb, bool DeuxCh, bool Enter=false)
{
        for (int k=0; k<Nb; k++) {
                if (DeuxCh) Wri_string(XS.FloatToStr   (f[k]),false);
                       else Wri_string(XS.FloatToStr2Ch(f[k]),false);
                if (k<Nb-1) Wri_string(" ",false);
        }
        if (Enter) Wri_Enter(1);
        return(true);
}
bool TFilew::Wri_charstar  (char * c)
{
    int n=0;
    char * cc = c;
    while (*cc) {cc++; n++;}
    Wri_data(c,n);
    return(true);
}


