#include "mpjv.h"

TSprite Sprite[NBSPRITEMAX]; // Sprite[0] est rserv pour la fonction mpjv.LoadTexture
bool ZeroZeroUp = false;

void TestSpr(bool trans){ if (trans) gl.EnableBlend(); else gl.DisableBlend();}
//----------------------------------------------------------------
void TSprite::Draw(float x, float y,float factX, float factY, float rot)
{
    TestSpr(Transp);
    int YC = ( ZeroZeroUp ? mpjv.ty-y-ty*factY/2 : y+ty*factY/2 );
    gl.CarrezCST2RotzCentre( x+tx*factX/2 , YC , tx*factX, ty*factY, 0, rot, Tex);
}
//----------------------------------------------------------------
void TSprite::DrawMiroir(float x, float y,float factX, float factY)
{
    TestSpr(Transp);   gl.CarrezCST2( x+tx*factX,y,x, y+ty*factY,0,Tex);
}
//----------------------------------------------------------------
bool TSprite::DrawCenterClicked(float x ,float y,  float size1,float r,float v, float b)
{
    bool IIN = false;
    if (SourisInCenter(x,y,size1,size1,0)) {IIN=true; mpjv.Color(r,v,b);}
    DrawCenter(x,y,size1,size1,0);
    mpjv.Color(1,1,1);
    if (IIN && Souris.LeftClick()) {Souris.MTime[M_LEFT]++;return(true);}
    return(false);
}
//----------------------------------------------------------------
void TSprite::DrawCenter(float xC,float yC, float factX=1, float factY=1,float Rot=0)
{
    int YC = ( ZeroZeroUp ? mpjv.ty-yC : yC );
    TestSpr(Transp);   gl.CarrezCST2RotzCentre( xC, YC, tx*factX,ty*factY,0,Rot,Tex);
}
//----------------------------------------------------------------
void TSprite::Load(string NomFich, bool transp)
{
    if (!Files.Exists(NomFich)) glSortirProprement(NomFich);
    XLoader.Load( NomFich,Tex, tx,ty,transp);
    Transp = transp;
}
//----------------------------------------------------------------
bool TSprite::SourisIn  (float x ,float y,  float factX=1, float factY=1, float rot=0)
{
    float FX =  (float)mpjv.txWindow / (float)mpjv.tx;
    float FY =  (float)mpjv.tyWindow / (float)mpjv.ty;
    int YC = ( ZeroZeroUp ? mpjv.ty - y - (ty*factY/2) :
                                      y + (ty*factY/2) );
    float Y1 = YC - ty*factY/2.0;
    float Y2 = YC + ty*factY/2.0;
    return (Souris.In( FX* x          , FY*Y1 ,
                       FX*(x+tx*factX), FY*Y2 ) );
}
//----------------------------------------------------------------
bool TSprite::SourisInCenter (float x ,float yC,  float factX=1, float factY=1, float rot=0)
{
    float FX =  (float)mpjv.txWindow / (float)mpjv.tx;
    float FY =  (float)mpjv.tyWindow / (float)mpjv.ty;
    int YC = ( ZeroZeroUp ? mpjv.ty - yC : yC );
    float Y1 = YC - ty*factY/2.0;
    float Y2 = YC + ty*factY/2.0;
    return (Souris.In( FX*(x-tx*factX*0.5) , FY*Y1 ,
                       FX*(x+tx*factX*0.5), FY*Y2 ) );
}
//**********************************************************************************
//**********************************************************************************
//**********************************************************************************
TTFont ttf[100];
Tmpjv mpjv;

void Reshape(int width, int height)
{
    F.Width  =width; // pour la souris... pfiouu..!! ( car c'est pas fait par WM_MSG .. )
    F.Height =height;

    mpjv.txWindow = width;
    mpjv.tyWindow = height;
    mpjv.FX = mpjv.txWindow/(float)mpjv.tx;
    mpjv.FY = mpjv.tyWindow/(float)mpjv.ty;
  	glViewport(0,0,width,height);  	glMatrixMode(GL_PROJECTION);  	glLoadIdentity();
  	gluOrtho2D(0,mpjv.tx,0,mpjv.ty);
}

void processMouse(int button, int state, int x, int y)
{
	//int specialKey = glutGetModifiers(); //specialKey == GLUT_ACTIVE_ALT
	if (button == GLUT_LEFT_BUTTON  ) Souris.ButtonL=1-state;
	if (button == GLUT_MIDDLE_BUTTON) Souris.ButtonM=1-state;
	if (button == GLUT_RIGHT_BUTTON ) Souris.ButtonR=1-state;
	Souris.OnMove(x,y);
}

void passivemotion( int x, int y )
{
    Souris.OnMove(x,y);
}
void Display()
{
    K.Refresh();
  	Souris.Refresh();
  	//XMod.Refresh();

 	glClear(GL_COLOR_BUFFER_BIT |GL_DEPTH_BUFFER_BIT);
    glId();

  	Loop();

    glutSwapBuffers();
    glutPostRedisplay();//Demande de recalculer la scne
}

void Tmpjv::Print       (float x , float y  , string str, int idx, float size1=1)
{
    if (ZeroZeroUp) y=ty-y;
    float FX =  (float)mpjv.txWindow / (float)mpjv.tx;
    float FY =  (float)mpjv.tyWindow / (float)mpjv.ty;
    ttf[idx].Print (FX*x ,FY*y,str,FX*size1);
}
void Tmpjv::PrintCenter (float xC, float yC , string str, int idx, float size1=1)
{
    if (ZeroZeroUp) yC=ty-yC;
    float FX =  (float)mpjv.txWindow / (float)mpjv.tx;
    float FY =  (float)mpjv.tyWindow / (float)mpjv.ty;
    ttf[idx].PrintCenter(FX*xC ,FY*yC,str,FX*size1);
}


void Tmpjv::Init(int w,int h, string Titre)
{
    char caca[] = "myprogram";
    char *my_argv[] = { caca , NULL };
    int   my_argc = 1;
    glutInit(&my_argc, my_argv);

    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    glutInitWindowSize(w,h);
    glutCreateWindow(Titre.c_str());
    tx       = w; ty       = h;
    txWindow = w; tyWindow = h;
    F.Width  = tx;
    F.Height = ty;

    /*
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP_TO_BORDER);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP_TO_BORDER);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    */

    glutMouseFunc        (processMouse);
    glutMotionFunc       (passivemotion);
    glutPassiveMotionFunc(passivemotion);
    //glutFullScreen(); 	//Optionnel

    glutReshapeFunc(Reshape);
    glutDisplayFunc(Display);

    //-----------------------------
    glEnable (GL_TEXTURE_2D);
    glDisable(GL_DEPTH_TEST);
}

void Tmpjv::Run()
{
    glutMainLoop();
}
