#ifndef _MPJV
#define _MPJV

#include "XDSFree.h"
#include "KTime.h"
#include "XCSGL.h"
//#include "XCSSon.h"
#define GLUT_NO_LIB_PRAGMA
#define GLUT_NO_WARNING_DISABLE
#include "glut.h"
#include <freetype/internal/internal.h>
#include "Nehe_FreeType.h"

const int NBSPRITEMAX = 2000;
extern bool ZeroZeroUp;
struct TSprite
{
    GLuint Tex;
    int tx, ty;
    bool Transp;

    void Load(string NomFich, bool transp);
    void Draw           (float x ,float y,  float factX, float factY, float rot);
    bool SourisIn       (float x ,float y,  float factX, float factY, float rot);
    bool SourisInCenter (float x ,float y,  float factX, float factY, float rot);

    void Draw      (float x ,float y,  float size1) {Draw(x,y,size1,size1,0);}
    void DrawRot   (float x ,float y,  float size1, float rot) {Draw(x,y,size1,size1,rot);}
    void DrawMiroir(float x ,float y,  float factX, float factY);
    void DrawMiroir(float x ,float y,  float size1) {DrawMiroir(x,y,size1,size1);}
    void DrawCenter(float xC,float yC, float factX, float factY,float Rot);
    void DrawCenter(float x ,float y,  float size1=1) {DrawCenter(x,y,size1,size1,0);}
    bool DrawCenterClicked(float x ,float y,  float size1=1,float r=1,float v=1, float b=1);
    void DrawCenterRot(float x ,float y,  float size1,float Rot) {DrawCenter(x,y,size1,size1,Rot);}
} extern Sprite[NBSPRITEMAX];

extern TTFont ttf[100];

struct Tmpjv
{
    void Init(int w,int h, string Titre);
    void Run();

    void   LoadTexture  (string NomFich,                  GLuint &TexOUT, bool Trsp=false) {TSprite S; S.Load(NomFich,Trsp);TexOUT = S.Tex;}
    void   LoadTexture  (string NomFich, int&tx, int &ty, GLuint &TexOUT, bool Trsp=false) {TSprite S; S.Load(NomFich,Trsp);TexOUT = S.Tex; tx=S.tx; ty=S.ty;}
    GLuint LoadTexture2 (string NomFich, bool Trsp=false) {Sprite[0].Load(NomFich,Trsp);return(Sprite[0].Tex);}

    void LoadSprite(string NomFich, int idx, bool Trsp=false) {Sprite[idx].Load(NomFich,Trsp);}
    void Draw       (float x , float y , int idx)                         {Sprite[idx].Draw(x,y,1);}
    void Draw       (float x , float y , int idx, float size1)            {Sprite[idx].Draw(x,y,size1);}
    void Draw       (float x , float y , int idx, float fx, float fy)     {Sprite[idx].Draw(x,y,fx,fy,0);}
    void DrawRot    (float x , float y , int idx, float size1,float rot)  {Sprite[idx].DrawRot(x,y,size1,rot);}
    void DrawRot    (float x , float y , int idx, float rot)         {Sprite[idx].DrawRot(x,y,1,rot);}
    void DrawMiroir (float x , float y , int idx)                    {Sprite[idx].DrawMiroir(x,y,1);}
    void DrawMiroir (float x , float y , int idx, float size1)       {Sprite[idx].DrawMiroir(x,y,size1);}
    void DrawCenter (float xC, float yC, int idx)                    {Sprite[idx].DrawCenter(xC,yC,1);}
    void DrawCenter (float xC, float yC, int idx, float size1)       {Sprite[idx].DrawCenter(xC,yC,size1);}
    void DrawCenter (float xC, float yC, int idx, float fx,float fy) {Sprite[idx].DrawCenter(xC,yC,fx,fy,0);}
    void DrawCenterRot     (float xC, float yC, int idx,float size1, float Rot)      {Sprite[idx].DrawCenterRot(xC,yC,size1,Rot);}
    bool DrawCenterClicked (float xC, float yC, int idx,float size,float r,float v,float b)
                           {return(Sprite[idx].DrawCenterClicked(xC,yC,size,r,v,b));}
    int txSprite(int idx) {return(Sprite[idx].tx);}
    int tySprite(int idx) {return(Sprite[idx].ty);}

    void LoadFont (string NomFich, float size, int idx){ttf[idx].LoadFont_FT(NomFich,size);}
    void Print       (float x , float y  , string str, int idx, float size1);
    void PrintCenter (float xC, float yC , string str, int idx, float size1);

    void Color(float r, float v, float b)                     {glColor3f(r,v,b);}
    void SetZeroZeroUp(bool ON) {ZeroZeroUp=ON;}

    int tx,ty,txWindow,tyWindow;
    float FX,FY;    // FX = txWindow/tx;
    Tmpjv() {FX=FY=1;}
} extern mpjv;

extern void Loop();

#endif
