//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****      X HTML - MARS 2013 - CopyRight  XCS Corporation		        *****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                                  *****
//***************************************************************************
//***************************************************************************

#define PORT 80

#include <stdio.h>
#include <stdlib.h>
#include <winsock2.h>
#include <algorithm>
#include "XDSFree2.h"
#include "XHTTP.h"
TMaster Master;
string Path="www";


void TAnalyse::StrCpyRes(char * dst)
{
    char * r = Res;
    while (*r) {*dst++ = *r++;};
    *dst=0;
}

void TAnalyse::ReadStrAct(char * dst)
{
    char * S=Str; char * D=Res;
    int k=0;
    while ((*S!=10)&&(*S!=13)&&(*S!=' ')&&(*S!=9)&&(*S)&&(k<1000)) {*D=*S; D++; S++; k++;} *D=0;
    Str=S;
    MoveToNxtChar();
    if (dst) StrCpyRes(dst);
}
void TAnalyse::ReadStrActDP(char * dst)
{
    char * S=Str; char * D=Res;
    int k=0;
    while ((*S!=10)&&(*S!=13)&&(*S!=':')&&(*S)&&(k<1000)) {*D=*S; D++; S++; k++;} *D=0;
    Str=S;
    if (dst) StrCpyRes(dst);
}
void TAnalyse::ReadFinLigne(char * dst)
{
    char * S=Str; char * D=Res;
    int k=0;
    while ((*S!=10)&&(*S!=13)&&(*S)&&(k<1000)) {*D=*S; D++; S++; k++;} *D=0;
    Str=S;
    if (dst) StrCpyRes(dst);
}


void TAnalyse::AnalyseHttp(char * DataIN, int size, SOCKADDR_IN &csin)
{
    char *ip = inet_ntoa(csin.sin_addr);
    printf("\n************* REQUETE de %s *********************\n",ip);
    printf  ("************* REQUETE de %s *********************\n",ip);
    printf("Received bytes : %d\n", size);
    printf("Received string :%s\n",DataIN);
    printf  ("************* REQUETE (fin) ***************\n");
    printf  ("************* REQUETE (fin) ***************\n\n");

    Data = DataIN;
    Str  = DataIN;

    //------ Premire ligne : GET !? -----------
    Type = 0;
    ReadStrAct(Req0); // GET
    ReadStrAct(Req1); // url
    ReadStrAct(Req2); // HTTP

    //------ Enttes HTTP ----------------------
    if ( !XS3.CmpDeb(Req0,(char*)"GET")  )
        glSortirProprement(DataIN); // BUUUGGGGG !!!!

    //------ Donnes qui suivent (!!?? kesako ?? ) --------
    ReqHost[0]=0;

    while (*Str!=10 && *Str!=13)
    {
        ReadStrActDP(DebLgn);
        if (*Str!=':') glSortirProprement("Manque le DP!");
        while (*Str==':' || *Str==' ') Str++;
        ReadFinLigne();
        if (XS3.CmpDeb(DebLgn,(char*)"Host"))
        {
            strcpy(ReqHost,Res);
        }
        if (*Str == 13) Str++;
        if (*Str != 10) glSortirProprement("Ligne finie trangement!?");
        Str++;
    }
}

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
//************************************************************************************************

//---- faut toujours qu'on ait 1 serveur qui coute le port 80,
//---- prt  crer un nouveau csock


void TMaster::InitReseau(string (*fctCallBack)(int,int))
{
    WSADATA WSAData;
    int erreur = WSAStartup(MAKEWORD(2,2), &WSAData);
    if (erreur) XS3.Quit("WSAStartup");

    /* Socket et contexte d'adressage du serveur */
    SOCKADDR_IN sin;
    int recsize = sizeof(sin);

    /* Cration d'une socket */
    sock = socket(AF_INET, SOCK_STREAM, 0);
    if (sock == INVALID_SOCKET) XS3.Quit("Invalid Socket");
    printf("La socket %d est maintenant ouverte en mode TCP/IP\n", sock);

    /* Configuration */
    sin.sin_addr.s_addr = htonl(INADDR_ANY);  /* Adresse IP automatique */
    sin.sin_family = AF_INET;                 /* Protocole familial (IP) */
    sin.sin_port = htons(PORT);               /* Listage du port */
    int sock_err = bind(sock, (SOCKADDR*)&sin, recsize);
    if(sock_err == SOCKET_ERROR) XS3.Quit("Bind socket");
    /* Ecoute - Connexion */
    printf("\n\n******** ECOUTE **********\n\n");
    sock_err = listen(sock, 10000);
    /* Xav : Fonction CallBack */
    fct = fctCallBack;
}


DWORD WINAPI GereVieCnx (LPVOID lpParameter)
{
    TConnexion * Cnx = new(TConnexion);    Master.NbCnx++;
    Cnx->CompleteLife();
    delete(Cnx);                           Master.NbCnx--;
    return(0);
}

void TMaster::NewConnexion()
{
    CreateThread(
    NULL,         //LPSECURITY_ATTRIBUTES lpThreadAttributes,
    0,            //SIZE_T dwStackSize,
    &GereVieCnx,  //LPTHREAD_START_ROUTINE lpStartAddress,
    0,            //LPVOID lpParameter,
    0,            //DWORD dwCreationFlags,
    NULL          //LPDWORD lpThreadId
    );
}


void TMaster::CloseReseau()
{
    printf("Fermeture de la socket serveur\n");     closesocket(sock);
    printf("Fermeture du serveur termine\n");      WSACleanup();
}

//************************************************************************************************************************
//************************************************************************************************************************
//************************************************************************************************************************
//************************************************************************************************************************

void TConnexion::CompleteLife()
{
    /* Socket et contexte d'adressage du client */
    int crecsize = sizeof(csin);

    printf("Ecoute du port %d...\n", PORT);
    printf("Patientez pendant que le client se connecte sur le port %d...\n", PORT);
    csock = accept(Master.sock, (SOCKADDR*)&csin, &crecsize);
    Master.NewConnexion();
    printf("Un client se connecte avec la socket %d de %s:%d\n", csock, inet_ntoa(csin.sin_addr), htons(csin.sin_port));

    int bytecount = 1;
    const int MAXBUF = 65537;
    char buffer[MAXBUF];
    while(bytecount > 0)
    {
        bytecount = recv(csock, buffer, MAXBUF, 0); // instruction BLOQUANTE !
        printf("--> bytecount %d\n",bytecount);

        if (bytecount > 0)
        {
            buffer[bytecount]=0;
            //------ Analyse --------
            Analyse.AnalyseHttp(buffer,bytecount,csin);
            //------ Rponse --------
                 if (XS3.CmpDeb(Analyse.Req1, (char*)"/XAV"))   { Send(2,Analyse.Req1);   }
            else if (XS3.CmpFin(Analyse.Req1, (char*)"ico"))    { Send(3,Analyse.Req1);   }
            else if (XS3.CmpFin(Analyse.Req1, (char*)"jpg"))    { Send(1,Analyse.Req1);   }
            else                                                { Send(0,Analyse.Req1);   }
        }
    }

    /* Fin connexion */
    printf("Fermeture de la socket client\n");            closesocket(csock);
}




void TConnexion::Send(int Type, char * URL)
{
    string StrURL = URL;
    string SS1 = "***** Type : "+XS.IntToStr(Type)+"\n";
    string SS2 = "***** URL  : "+StrURL+"\n";
    printf("\n************* REPONSE *********************\n");
    printf  ("************* REPONSE *********************\n");
    printf(SS1.c_str());
    printf(SS2.c_str());

    //--- 0 --- Cration du CORPS de la rponse
    //--- 0 --- Cration du CORPS de la rponse
    //--- 0 --- Cration du CORPS de la rponse
    TFile   F;
    TFilerb Fb;
    int CSize; // Corps Size
    string NomFichTot;
    string ContentType = "text/HTML";
    string Msg;

    if (Type==0 || Type==1)
    {
        NomFichTot = URL;
        if (URL[0]==0 || URL[1]==0) NomFichTot="/index.html";
        NomFichTot = Path + NomFichTot;
        if (!Files.Exists(NomFichTot)) glSortirProprement(NomFichTot);

        CSize = Files.Size(NomFichTot);
        if (Type==0) {F.Load(NomFichTot);Msg=F.Data;}
        if (Type==1) {Fb.Load(NomFichTot);ContentType = "image/jpeg";}
    }
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    if (Type==2)
    {
        char * s = URL;
        int ID    = 0;
        int RADIO = 0;
        if (XS3.MoveAfterChar(s,'?'))
        {
            do
            {
                if (*s==';') s++;

                if (XS3.CmpDeb(s,(char*)"ID="))
                {
                    XS3.MoveAfterChar(s,'=');
                    ID = XS3.GetNumber(s);
                }
                if (XS3.CmpDeb(s,(char*)"RADIO="))
                {
                    XS3.MoveAfterChar(s,'=');
                    RADIO = XS3.GetNumber(s);
                }

            }while (*s==';');
        }
        printf("--> Message XAV <--   ID=%d\n",ID);
        Msg   = Master.fct(ID,RADIO);
        CSize = Msg.size();
    }
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    // Traitement du /XAV ****** SEULES LIGNES  modifier dans cette bibliothque
    if (Type==3)
    {
        Msg   = "";
        CSize = Msg.size();
    }

    //--- 1 --- Cration entte
    //--- 1 --- Cration entte
    //--- 1 --- Cration entte
    string Entete = "HTTP/1.1 200 OK\n";
    Entete += "Content-Type: "+ContentType+"\n";
    Entete += "Content-Length: " + XS.IntToStr(CSize) + "\n";
    Entete += "Connection: keep-alive\n";
    Entete += "\n"; // fin de l'entte.

    //--- 2 --- Rponse = Entte + Corps
    //--- 2 --- Rponse = Entte + Corps
    //--- 2 --- Rponse = Entte + Corps
    if (Type==0 || Type==2 || Type==3 )
    {
        Msg = Entete + Msg;
        send( csock, Msg.c_str() , Msg.size() , 0);
        if (XS3.CmpFin(URL,(char*)"js")) printf(URL); else printf(Msg.c_str());
        printf("\n");
    }
    if (Type==1)
    {
        int SizeTot = Entete.size() + CSize;
        char * rep = (char*) malloc( SizeTot );
        memcpy(rep, Entete.c_str(), Entete.size());
        memcpy(&rep[Entete.size()] , Fb.p , CSize);
        send( csock, rep, SizeTot , 0);
    }

    printf  ("************* REPONSE (fin) ***************\n");
    printf  ("************* REPONSE (fin) ***************\n\n");
    //--- FIN --- Libration
    //--- FIN --- Libration
    //--- FIN --- Libration
    if (Type==0) F.FreeData();
    if (Type==1) Fb.Free();
}

